unit AComp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, keyboard, comctrls;

type


(* * * * * * * * * *
 ARABIC EDIT
 * * * * * * * * * *)
  TAEdit = class(TEdit)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC MEMO
 * * * * * * * * * *)
  TAMemo = class(TMemo)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC BUTTON
 * * * * * * * * * *)
  TAButton = class(TButton)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC CHECKBOX
 * * * * * * * * * *)
  TACheckBox = class(TCheckBox)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC RADIOBUTTON
 * * * * * * * * * *)
  TARadioButton = class(TRadioButton)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC LISTBOX
 * * * * * * * * * *)
  TAListBox = class(TListBox)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC COMBOBOX
 * * * * * * * * * *)
  TAComboBox = class(TComboBox)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC GROUPBOX
 * * * * * * * * * *)
  TAGroupBox = class(TGroupBox)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC SCROLLBOX
 * * * * * * * * * *)
  TAScrollBox = class(TScrollBox)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;
(* * * * * * * * * *
 ARABIC RICHEDIT
 * * * * * * * * * *)
  TARichEdit = class(TRichEdit)
  private
    { Private declarations }
    FArabic: Boolean;
    procedure SetArabic ( b:Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Arabic:Boolean read FArabic write SetArabic default true;
  end;

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   IMPLEMENTATION
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Rayed Comp', [TAEdit]);
  RegisterComponents('Rayed Comp', [TAMemo]);
  RegisterComponents('Rayed Comp', [TAButton]);
  RegisterComponents('Rayed Comp', [TACheckBox]);
  RegisterComponents('Rayed Comp', [TARadioButton]);
  RegisterComponents('Rayed Comp', [TAListBox]);
  RegisterComponents('Rayed Comp', [TAComboBox]);
  RegisterComponents('Rayed Comp', [TAGroupBox]);
  RegisterComponents('Rayed Comp', [TAScrollBox]);
  RegisterComponents('Rayed Comp', [TARichEdit]);
end;


// * * * * * * * * *
// ARABIC EDIT
// * * * * * * * * *
constructor TAEdit.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAEdit.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT ;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC MEMO
// * * * * * * * * *
constructor TAMemo.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAMemo.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAMemo.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC BUTTON
// * * * * * * * * *
constructor TAButton.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAButton.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAButton.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING; // or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC CHECKBOX
// * * * * * * * * *
constructor TACheckBox.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TACheckBox.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TACheckBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC RADIOBUTTON
// * * * * * * * * *
constructor TARadioButton.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TARadioButton.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TARadioButton.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC LISTBOX
// * * * * * * * * *
constructor TAListBox.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAListBox.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAListBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT or WS_EX_LEFTSCROLLBAR ;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC COMBOBOX
// * * * * * * * * *
constructor TAComboBox.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAComboBox.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAComboBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC GROUPBOX
// * * * * * * * * *
constructor TAGroupBox.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAGroupBox.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAGroupBox.Paint;
var
  H: Integer;
  R: TRect;
begin
  with Canvas do
  begin
    Font := Self.Font;
    H := TextHeight('0');
    R := Rect(0, H div 2 - 1, Width, Height);
    if Ctl3D then
    begin
      Inc(R.Left);
      Inc(R.Top);
      Brush.Color := clBtnHighlight;
      FrameRect(R);
      OffsetRect(R, -1, -1);
      Brush.Color := clBtnShadow;
    end else
      Brush.Color := clWindowFrame;
    FrameRect(R);
    if Text <> '' then
       if FArabic
       then begin
            R := Rect(0, 0, 0, H);
            DrawText(Handle, PChar(Text), Length(Text), R, DT_RIGHT or DT_RTLREADING or DT_SINGLELINE or DT_CALCRECT);
            Brush.Color := Color;
            R.left := width - R.right - 8 ;
            R.Right:= width - 8 ;
            DrawText(Handle, PChar(Text), Length(Text), R, DT_RIGHT or DT_RTLREADING or DT_SINGLELINE);
            end
       else begin
            R := Rect(8, 0, 0, H);
            DrawText(Handle, PChar(Text), Length(Text), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
            Brush.Color := Color;
            DrawText(Handle, PChar(Text), Length(Text), R, DT_LEFT or DT_SINGLELINE);
            end

  end;
end;
// * * * * * * * * *
// ARABIC SCROLLBOX
// * * * * * * * * *
constructor TAScrollBox.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TAScrollBox.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TAScrollBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT or WS_EX_LEFTSCROLLBAR ;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;
// * * * * * * * * *
// ARABIC RIHEDIT
// * * * * * * * * *
constructor TARichEdit.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FArabic:= True;
end;

procedure TARichEdit.SetArabic ( b:Boolean);
begin
 FArabic:= b;
 ReCreateWnd;
end;

procedure TARichEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);	{ call the inherited first }
  if FArabic
     then begin
          Params.ExStyle := Params.ExStyle or WS_EX_RTLREADING or WS_EX_RIGHT;
          LoadKeyBoardLayout ( '00000401', KLF_ACTIVATE);
          end;
end;


end.
